package betterwithmods.common.blocks.tile;

import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.EnumParticleTypes;
import net.minecraft.util.ITickable;
import net.minecraft.util.math.BlockPos;
import net.minecraftforge.common.ForgeHooks;

/**
 * Created by tyler on 9/11/16.
 */
public class TileEntityInfernalEnchanter extends TileBasic implements ITickable {
    private final static int RADIUS = 8;
    private int bookcaseCount;

    @Override
    public void func_73660_a() {

        if (func_145831_w().func_82737_E() % 20 == 0) {
            bookcaseCount = 0;
            for (int x = -RADIUS; x <= RADIUS; x++) {
                for (int y = -RADIUS; y <= RADIUS; y++) {
                    for (int z = -RADIUS; z <= RADIUS; z++) {
                        BlockPos pos = func_174877_v().func_177982_a(x, y, z);
                        bookcaseCount += (ForgeHooks.getEnchantPower(func_145831_w(), pos) > 0) ? 1 : 0;
                    }
                }
            }

            //required

            // bookcase * item.enchants + 1

        }
        if (func_145831_w().func_82737_E() % 5 == 0) {
            int x = field_174879_c.func_177958_n(), y = field_174879_c.func_177956_o(), z = field_174879_c.func_177952_p();
            func_145831_w().func_175688_a(EnumParticleTypes.FLAME, x + .125, y + .9, z + .125, 0, 0, 0);
            func_145831_w().func_175688_a(EnumParticleTypes.FLAME, x + .875, y + .9, z + .125, 0, 0, 0);
            func_145831_w().func_175688_a(EnumParticleTypes.FLAME, x + .875, y + .9, z + .875, 0, 0, 0);
            func_145831_w().func_175688_a(EnumParticleTypes.FLAME, x + .125, y + .9, z + .875, 0, 0, 0);
        }

    }

    public int getBookcaseCount() {
        return bookcaseCount;
    }

    public void setBookcaseCount(int bookcaseCount) {
        this.bookcaseCount = bookcaseCount;
    }

    @Override
    public NBTTagCompound func_189515_b(NBTTagCompound compound) {
        compound.func_74768_a("bookcaseCount", bookcaseCount);
        return super.func_189515_b(compound);
    }

    @Override
    public void func_145839_a(NBTTagCompound compound) {
        bookcaseCount = compound.func_74762_e("bookcaseCount");
        super.func_145839_a(compound);
    }

    public String getName() {
        return "bwm.infernalenchanter";
    }
}
